unit Monosubstitution;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Menus, Info, HilfeRegeln, ComCtrls;

type
  TMonosub = class(TForm)
    LabelCode: TLabel;
    LabelOriginal: TLabel;
    LabelAusgabe: TLabel;
    LabelS: TLabel;
    EditH: TEdit;
    DateiLesen: TOpenDialog;
    Ausgabe: TMemo;
    LabelK: TLabel;
    LabelC: TLabel;
    KTA: TStringGrid;
    CTA: TStringGrid;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    TrennlinieD: TMenuItem;
    Beenden: TMenuItem;
    Zaehlen: TMenuItem;
    Decodieren: TMenuItem;
    Hilfe: TMenuItem;
    DateiSpeichern: TSaveDialog;
    Tips: TMenuItem;
    TrennlinieH: TMenuItem;
    Info: TMenuItem;
    CodeBox: TMemo;
    Original: TMemo;
    Neu: TMenuItem;
    Codieren: TMenuItem;
    VArt: TMenuItem;
    Start: TMenuItem;
    Alphabet: TMenuItem;
    Standard: TMenuItem;
    Erweitert: TMenuItem;
    Landessprache: TMenuItem;
    Deutsch: TMenuItem;
    Englisch: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    procedure ZaehlenClick(Sender: TObject);
    procedure Entschluesseln;
    procedure Verschluesseln;
    procedure DecodierenClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure TipsClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure NeuClick(Sender: TObject);
    procedure CodierenClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure DeutschClick(Sender: TObject);
    procedure EnglischClick(Sender: TObject);
    procedure StandardClick(Sender: TObject);
    procedure ErweitertClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Monosub: TMonosub;

implementation

{$R *.DFM}
{$R+,Q+}

 procedure TMonosub.FormCreate(Sender: TObject);
  var X:Byte;
  begin
   for X:=0 to 25 do
    KTA.Cells[X,0]:=Char(X+97);
  end;

 procedure TMonosub.LadenClick(Sender: TObject);
  var K:Integer;
      Liste:TStrings;
  begin
   with DateiLesen do
    begin
     Filter:='Textdateien (*.txt)|*.txt';
     DefaultExt:='txt';
     if Execute then
      Begin
       Screen.Cursor:=crHourGlass;
       Liste:=TStringList.Create;
       Liste.LoadFromFile(filename);
       For K:=0 to Liste.Count-1 do Liste[K]:=AnsiUpperCase(Liste[K]);
       CodeBox.Lines:=Liste;
       Liste.Free;
       Screen.Cursor:=crDefault
      End
     else
      begin
       MessageDlg('Es wurde keine Datei gewhlt!',mtError,[mbOk],0);
       exit
      end;
    end;
  end;

 procedure TMonosub.ZaehlenClick(Sender: TObject);
  VAR OFT:ARRAY[1..96]OF Integer;
      I,L,M,N,OftN,CODELAENGE,ZAEHLER,Wo:Integer;
      Alfabet,WERT,AUSGABETEIL,CODETEXT,Zeile,Alfa:STRING;
      ZEICHEN:CHAR;
      FERTIG:BOOLEAN;
  begin
   Screen.Cursor:=crHourGlass;
   Alfabet:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   if Standard.Checked then
    Begin Alfa:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';OftN:=26 End
   else
    Begin
     Alfa:='';
     For I:=32 to 127 do Alfa:=Alfa+Char(I);
     OftN:=96
    End;
   FOR I:=1 TO OftN DO OFT[I]:=0;
   Ausgabe.Clear;
   CODETEXT:='';N:=CodeBox.Lines.Count;
   FOR I:=1 TO N DO
    FOR L:=1 TO LENGTH(CodeBox.Lines[I-1]) DO
     BEGIN
      ZEICHEN:=CodeBox.Lines[I-1][L];M:=POS(ZEICHEN,CODETEXT);
      IF (M=0) AND (POS(ZEICHEN,Alfa)>0) THEN
       BEGIN CODETEXT:=CODETEXT+ZEICHEN;M:=POS(ZEICHEN,CODETEXT) END;
      IF M>0 THEN INC(OFT[M])
     END;
   CODELAENGE:=LENGTH(CODETEXT);
   REPEAT
    FERTIG:=TRUE;
    FOR I:=1 TO CODELAENGE-1 DO
     IF OFT[I]<OFT[I+1] THEN
      BEGIN
       ZAEHLER:=OFT[I];OFT[I]:=OFT[I+1];OFT[I+1]:=ZAEHLER;
       ZEICHEN:=CODETEXT[I];CODETEXT[I]:=CODETEXT[I+1];
       CODETEXT[I+1]:=ZEICHEN;FERTIG:=FALSE
      END
   UNTIL FERTIG;
   For I:=0 to 25 do CTA.Cells[I,0]:='';
   Zeile:='';
   if Length(EditH.Text)<26 then
    begin
     if Deutsch.Checked then EditH.Text:='ENRISTDHAULCGMOBZWFKVPJYQX'
     else EditH.Text:='EAOIDHNRSTUYCFGLMWBKPQXZJV';
    end;
   for I:=1 to 26 do
    if pos(Alfabet[I],EditH.Text)=0 then
     begin
      MessageDLG('das '+Alfabet[I]+' fehlt!',mtError,[mbOk],0);
      Screen.Cursor:=crDefault;
      exit
     end;
   FOR I:=1 TO CODELAENGE DO
    BEGIN
     if I<27 then
      Begin
       Wo:=Ord(EditH.Text[I])-65;
       CTA.Cells[Wo,0]:=CODETEXT[I];
      End;
     Str(OFT[I]:6,WERT);
     AUSGABETEIL:='Das Zeichen '+CODETEXT[I]+' kommt '+WERT+' mal vor';
     Zeile:=Zeile+AUSGABETEIL+'     ';
     IF I MOD 2=0 THEN BEGIN AUSGABE.Lines.Add(Zeile);Zeile:='' END
    END;
   If Odd(Codelaenge) then AUSGABE.Lines.Add(Zeile);
   Screen.Cursor:=crDefault;
  end;

 procedure TMonosub.DecodierenClick(Sender: TObject);
  BEGIN
   Decodieren.Checked:=True;
  end;

 procedure TMonosub.Entschluesseln;
  VAR I,L,M,N:Integer;
      CodeTextAlfa,Zeile,Alfa,CodeZeile:STRING;
      ZEICHEN:CHAR;
  begin
   Screen.Cursor:=crHourGlass;
   LabelOriginal.Caption:='Original';
   LabelCode.Caption:='codierte Daten';
   Alfa:='abcdefghijklmnopqrstuvwxyz';Original.Clear;
   For I:=0 to 25 do KTA.Cells[I,0]:=Alfa[I+1];
   CodeTextAlfa:='';N:=CodeBox.Lines.Count-1;
   For I:=0 to 25 do
    if CTA.Cells[I,0]='' then CodeTextAlfa:=CodeTextAlfa+'*'
    else CodeTextAlfa:=CodeTextAlfa+CTA.Cells[I,0];
   FOR I:=0 TO N DO
    BEGIN
     Zeile:='';CodeZeile:=AnsiUpperCase(CodeBox.Lines[I]);
     CodeBox.Lines[I]:=CodeZeile;
     FOR L:=1 TO LENGTH(CodeZeile) DO
      BEGIN
       ZEICHEN:=CodeZeile[L];M:=POS(ZEICHEN,CodeTextAlfa);
       IF M>0 THEN Zeile:=Zeile+Alfa[M]
       ELSE Zeile:=Zeile+ZEICHEN
      END;
     ORIGINAL.Lines.Add(Zeile);
    END;
   Screen.Cursor:=crDefault;
  end;

 procedure TMonosub.BeendenClick(Sender: TObject);
  begin
   Close;
  end;

 procedure TMonosub.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Willst du wirklich beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Die Zhlerei hat ein Ende.', mtInformation,[mbOk], 0);
     CanClose:=True;
    end
   else CanClose:=False;
  end;

 procedure TMonosub.SpeichernClick(Sender: TObject);
  begin
   with DateiSpeichern do
    begin
     Filter:='Textdateien (*.txt)|*.txt';
     DefaultExt:='txt';
     Options:=[ofOverwritePrompt];
     if Execute then Original.Lines.SaveToFile(Filename)
     else
      begin
       MessageDlg('Es wurde keine Datei gewhlt!',mtError,[mbOk],0);
       exit
      end;
    end;
  end;

 procedure TMonosub.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TMonosub.TipsClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

 procedure TMonosub.NeuClick(Sender: TObject);
  var I:Integer;
  begin
   CodeBox.Clear;Original.Clear;Ausgabe.Clear;
   For I:=0 to 25 do CTA.Cells[I,0]:='';
  end;

 procedure TMonosub.CodierenClick(Sender: TObject); // Text verschlsseln
  begin
   Codieren.Checked:=True;
  end;

 procedure TMonosub.Verschluesseln;
  var I,Wo,K,L,M,N:Integer;
      ZufallsStart,CodeTextAlfa,Zeile,Alfa,CodeZeile,CodeText,Alphabet:STRING;
      ZEICHEN:CHAR;
      Ok:Boolean;
  begin
   Screen.Cursor:=crHourGlass;Original.Clear;
   LabelOriginal.Caption:='codierte Daten';
   LabelCode.Caption:='Original';
   CodeTextAlfa:='abcdefghijklmnopqrstuvwxyz';
   if Standard.Checked then CodeText:='CAUGSTEDPINOQRVWXYZBFHJKLM'
   else CodeText:='!"~$%&/()=?#-.,:;984657<>@';
   ZufallsStart:='-500';
   Ok:=InputQuery('Zufallsalfabet','Gib deine Startzahl ein',ZufallsStart);
   if Not Ok then ZufallsStart:='4711';
   RandSeed:=StrToInt(ZufallsStart);Alphabet:='';
   for K:=1 to 26 do
    begin
     repeat
      wo:=random(26)+1;
     until CodeText[wo]<>#0;
     Alphabet:=Alphabet+CodeText[wo];
     CodeText[wo]:=#0;
    end;
   For I:=0 to 25 do KTA.Cells[I,0]:=CodeTextAlfa[I+1];
   For I:=0 to 25 do CTA.Cells[I,0]:=Alphabet[I+1];
   Alfa:='';N:=CodeBox.Lines.Count-1;
   For I:=0 to 25 do
    if CTA.Cells[I,0]='' then Alfa:=Alfa+'*'
    else Alfa:=Alfa+CTA.Cells[I,0];
   FOR I:=0 TO N DO
    BEGIN
     Zeile:='';CodeZeile:=AnsiLowerCase(CodeBox.Lines[I]);
     CodeBox.Lines[I]:=CodeZeile;
     FOR L:=1 TO LENGTH(CodeZeile) DO
      BEGIN
       ZEICHEN:=CodeZeile[L];M:=POS(ZEICHEN,CodeTextAlfa);
       IF M>0 THEN Zeile:=Zeile+Alfa[M]
       ELSE Zeile:=Zeile+ZEICHEN
      END;
     ORIGINAL.Lines.Add(Zeile);
    END;
   Screen.Cursor:=crDefault;
  end;

 procedure TMonosub.StartClick(Sender: TObject);
  begin
   if Codieren.Checked then Verschluesseln
   else Entschluesseln;
  end;

 procedure TMonosub.DeutschClick(Sender: TObject);
  begin
   Deutsch.Checked:=True;
   LabelS.Caption:='Hufigkeit im Deutschen';
   EditH.Text:='ENRISTDHAULCGMOBZWFKVPJYQX';
//     EditH.Text:='ENISRDATHUGLCOBKMWZFVPJYQX'; // fr Stufe1
  end;

 procedure TMonosub.EnglischClick(Sender: TObject);
  begin
   Englisch.Checked:=True;
   LabelS.Caption:='Hufigkeit im Englischen';
//     EditH.Text:='ETHOSNAIRDFLBMGYUVPCKJWQXZ'; // fr Goldkfer
   EditH.Text:='EAOIDHNRSTUYCFGLMWBKPQXZJV';
  end;

 procedure TMonosub.StandardClick(Sender: TObject);
  begin
   Standard.Checked:=True;
  end;

 procedure TMonosub.ErweitertClick(Sender: TObject);
  begin
   Erweitert.Checked:=True;
  end;

end.

